/*------------------------------------------------------------------------------------------------------------------------------
# Nome:		ClienteOpenChat.java
# Finalidade:	Cliente no
#
# Author:		Cesar Kallas		cesarkallas at gmx.net 			http://cesarkallas.soulivre.org
#			Renan Fernanades 	renanfernandes at gmail.com		http://renanfernandes.soulivre.org
# Copyright:   (c) 2005
# Licence:     GNU/GPL
# Pontificia Univerisidade Catolica - Puc Campinas - Brasil
#------------------------------------------------------------------------------------------------------------------------------*/

package openchat.cliente;

import openchat.cliente.Historico;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class ClienteOpenChat
{
	private int UsuarioID;
	private String UsuarioSenha, HostServer;
	private int PortServer, PortClient;
			
	public ClienteOpenChat()
	{
		try {			
			LoginUsuario L = new LoginUsuario(0);
			L.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}
		catch(Exception Server)	
		{
			JOptionPane.showMessageDialog(null,"Erro ao criar o cliente local. verifique a porta: "+PortClient+" ]");
			System.out.println(Server.getMessage());
			System.exit(0);
		}
	}
}
/*
 * Tela de login do usuario
 */
class LoginUsuario extends JFrame
{
	private JLabel LabelId,Pass,Hello;
	private JTextField Id;
	private JPasswordField Senha;
	private int UsuarioID, PortServer=10000, PortClient=10001, LastId=0, tempID;
	private String UsuarioSenha, HostServer="", login;
	private boolean check=true;
	private Socket MSG;
	private BufferedReader Reply;
	private PrintWriter Send;
	private String Token = new String("~~~~~~~~~~~~~~~"), fraseSecreta;
	private String Message, respostaLogin;
	private ButtonHandler handler;
  private JButton Entrar;
	static ImageIcon iconeEntrar		= new ImageIcon("icons/ok.png");
	static ImageIcon iconeGlobo		= new ImageIcon("icons/url.png");
	static ImageIcon iconeSalvar		= new ImageIcon("icons/file.png");
	static ImageIcon iconeOpcoes		= new ImageIcon("icons/opcoes.png");
	static ImageIcon iconeNovoUsuario	= new ImageIcon("icons/usuario.png");
	static ImageIcon iconClose		= new ImageIcon("icons/cancel.png");
	
	public LoginUsuario(int tempID)
	{
		super("OpenChat");
		
		try {
			ReadFile();
		} catch(Exception READ){}

		this.tempID = tempID;
		Token = new String("~~~~~~~~~~~~~~~");
		JPanel Login 	= new JPanel();
		Login.setLayout(new BorderLayout());
			
		Hello	= new JLabel("Dados do Usuario",JLabel.CENTER);
		LabelId	= new JLabel("id ",JLabel.RIGHT);
		Pass 	= new JLabel("senha ",JLabel.RIGHT);
		
		JPanel Status =  new JPanel();
		Status.setLayout( new GridLayout(2,1));
		Login.add(Status,BorderLayout.LINE_START);
			
		Login.add(Hello,BorderLayout.NORTH);
		Status.add(LabelId);
		Status.add(Pass);
		
		JPanel L = new JPanel();
		L.setLayout(new GridLayout(2,1));
		Login.add(L,BorderLayout.CENTER);
		
		Id = new JTextField(12);
    Id.addKeyListener(new KeyAdapter() {
		public void keyTyped(KeyEvent e) {
			int i=Id.getText().length();
    	char c = e.getKeyChar();      
    	if (!((Character.isDigit(c) ||	(c == KeyEvent.VK_BACK_SPACE) || (c == KeyEvent.VK_DELETE)))) {
     			e.consume();
				}
				if (((i>25))) {
					e.consume();
				} else
					i++;
				} });	

		L.add(Id);
		if(tempID == 0)
			Id.setText(""+LastId);
		else
			Id.setText(""+tempID);
		
		Senha = new JPasswordField(25);
		Senha.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=Senha.getPassword().length;
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});
		L.add(Senha);
		
		Panel Buttons = new Panel();
		Buttons.setLayout(new GridLayout(2,2));
		Login.add(Buttons,BorderLayout.PAGE_END);

		Entrar		= new JButton("Entrar", iconeGlobo);
		JButton BNovoUsuario	= new JButton("Novo Usuario", iconeNovoUsuario);
		JButton Opcoes		= new JButton("Opcoes", iconeOpcoes);
		JButton Cancelar	= new JButton("Cancelar", iconClose);
    
    Id.addKeyListener (
		  new KeyAdapter () {
			public void keyPressed (KeyEvent e)
			{ 
        if ((int)e.getKeyChar () == KeyEvent.VK_ENTER)
          Senha.requestFocus();
      }
		  }
		);
          
    Senha.addKeyListener (
		  new KeyAdapter () {
			public void keyPressed (KeyEvent e)
			{ 
        if ((int)e.getKeyChar () == KeyEvent.VK_ENTER)
          Entrar.requestFocus();
			  if ((int)e.getKeyChar () == KeyEvent.VK_ESCAPE)
				  dispose();
			}
		  }
		);
      
		Buttons.add(Entrar);
		Buttons.add(BNovoUsuario);
		Buttons.add(Opcoes);
		Buttons.add(Cancelar);
	
		// Handlers dos Botoes
		handler = new ButtonHandler();
		Entrar.addActionListener(handler);
		Cancelar.addActionListener(handler);
		BNovoUsuario.addActionListener(handler);
		Opcoes.addActionListener(handler);

		// Tooltips - Dicas
		BNovoUsuario.setToolTipText("Clique aqui e crie um novo usuario para conversar no OpenChat.");
		Entrar.setToolTipText("Preencha seu ID e sua senha e clique aqui para entrar na rede OpenChat.");
		Opcoes.setToolTipText("Altere as Opcoes de Conexao do OpenChat.");

		getContentPane().add(Login);

		setResizable(true);
		setLocation(362,317);
		setSize(300,150);
		setVisible(true);
		
		show();
		Senha.requestFocus();
	}
	/* Handlers dos botoes
	* Aqui vamos tratar o que acontece quando os botoes
	* forem clicados
	*/
	public class ButtonHandler implements ActionListener
	{
		int opcao;
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Entrar"))
			{
				try {
					if(Id.getText().length() == 0 || Senha.getPassword().length == 0 )
						JOptionPane.showMessageDialog(null,"Por Favor, preencha os dados corretamente.");
					else
					{
						try {
							UsuarioID = Integer.parseInt(Id.getText());
							UsuarioSenha = new String(Senha.getPassword());
						}
						catch(Exception I) {
							JOptionPane.showMessageDialog(null,"O Valor do ID est incorreto (apenas nmeros)");
							return;
						}
						
						try	{
							MSG = new Socket(HostServer, PortServer);
							Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
							Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
					  }
						catch(IOException Socket) {
							JOptionPane.showMessageDialog(null,"Erro na tentativa de conectar ao servidor: [ "+HostServer+" : "+PortServer+" ]\n\n"+Socket.getMessage());
							return;
						}					
							
						try {
							Message = new String("Login"+Token+UsuarioID+Token+UsuarioSenha+Token+PortClient);
							Send.println(Message);
							Send.flush();
							respostaLogin = new String(Reply.readLine());
							login = new String(Reply.readLine());
						}
						catch(IOException RUL) {
							JOptionPane.showMessageDialog(null,"Falha ao logar no servidor:: [ "+HostServer+" : "+PortServer+" ]\n\n"+RUL.getMessage());
							return;
						}
						try {
							if(respostaLogin.equals("false")) {
								Object[] options = { "Esqueci a senha", "Tentar novamente"};
								opcao = JOptionPane.showOptionDialog(null,
								"\nFalha ao conectar \nPossveis falhas:\n\n1. O ID ou a senha esto incorretos\n2. O Cliente ja esta conectado \n ", 								
								"Falha ao conectar", 
								JOptionPane.DEFAULT_OPTION, 
								JOptionPane.WARNING_MESSAGE, 
								null, 
								options, 
								options[0]);
							}
              else {
								int TEMPID=0;
								if(check)
									TEMPID=UsuarioID;
								EscreveArquivo(HostServer+"\n"+PortServer+"\n"+PortClient+"\n"+TEMPID);
								Send.close();
								Reply.close();
								MSG.close();
								dispose();
								new ClientMain(HostServer,PortServer,PortClient,Integer.parseInt(Id.getText()), login, UsuarioSenha).start();
                return;
							}
              // Esqueceu a senha
              if(opcao==0) {
                String tempFraseSecreta = new String("Seu ID:  ");
                tempFraseSecreta += UsuarioID + "\n\nDigite sua frase secreta:";
                fraseSecreta = JOptionPane.showInputDialog(tempFraseSecreta);
                Message = new String("ConfFraseScreta"+Token+UsuarioID+Token+fraseSecreta);
                if(fraseSecreta!=null) {
                  try {
                    try	{
                      MSG = new Socket(HostServer, PortServer);
                      Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
                      Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
                    }
                    catch(IOException Socket) {
                      JOptionPane.showMessageDialog(null,"Falha ao conectar no servidor: [ "+HostServer+" : "+PortServer+" ]\n\n"+Socket.getMessage());
                      return;
                    }
                    Send.println(Message);
                    Send.flush();
                    respostaLogin = new String(Reply.readLine());
                  }
                  catch(IOException E2) {
                    JOptionPane.showMessageDialog(null, "Falha ao buscar senha secreta do usuario");
                    System.err.println(E2.getMessage());
                    dispose();
                  }
                  if(!respostaLogin.equals("")) {
                    tempFraseSecreta = "Seu ID: " + UsuarioID + "\nSua senha: " + respostaLogin;
                    JOptionPane.showMessageDialog(null, tempFraseSecreta);
                  } else
                    JOptionPane.showMessageDialog(null, "A sua frase secreta est incorreta!", null, JOptionPane.WARNING_MESSAGE);
                }
              }
						}
						catch(Exception CON) {
							JOptionPane.showMessageDialog(null,"\nFalha ao conectar\nVerifique se o servidor est online! \n ","Falha",JOptionPane.ERROR_MESSAGE);
							System.err.println(CON.getMessage());
						}
					}
            Senha.setText("");
            Senha.requestFocus();
				}
				catch(Exception Entrar) {
					System.err.println(Entrar.getMessage());
				}
			}
			
			if(E.getActionCommand().equals("Cancelar"))
			{
				System.exit(0);
			}
			
			if(E.getActionCommand().equals("Novo Usuario"))
			{
				new NewUser(HostServer,PortServer,PortClient).start();
				
				dispose();
			}
			
			if(E.getActionCommand().equals("Opcoes"))
			{
				setVisible(false);
				new OpcoesCliente().start();
			}
				
		}
	}

	public int ReturnId()
	{
		return UsuarioID;
	}
	
	public String ReturnPassword()
	{
		return UsuarioSenha;
	}
	
	class OpcoesCliente extends Thread
	{
		private JFrame jFrame;
		private JPanel jPanel, jButtons, L, R;
		private JButton BotaoAtualizar, BotaoFechar;
		private JLabel labelIpServer, labelPortServer, labelRemember, labelOptions, labelPortClient;
		private JTextField IpServer, PortS, PortC;
		private Checkbox Remember;
		
		public void run()
		{
			jFrame	= new JFrame();
			jPanel	= new JPanel(new BorderLayout());
			L		= new JPanel(new GridLayout(4,1));
			R		= new JPanel(new GridLayout(4,1));
			jButtons	= new JPanel(new GridLayout(1,2));
		
			labelOptions	= new JLabel("Opcoes", JLabel.CENTER);
			labelOptions.setForeground(Color.blue);
			
			labelIpServer	= new JLabel(" IP do Servidor ");
			labelPortServer	= new JLabel(" Porta do Servidor ");
			labelPortClient	= new JLabel(" Porta do Cliente ");
			labelRemember	= new JLabel(" Gravar o ultimo ID ");
					
			L.add(labelIpServer);
			L.add(labelPortServer);
			L.add(labelPortClient);
			L.add(labelRemember);
	
			Remember	= new Checkbox("sim");
			IpServer	= new JTextField();
			PortS		= new JTextField();
			PortC 		= new JTextField();

			try
			{
				IpServer.setText(""+HostServer);
				PortS.setText(""+PortServer);
				PortC.setText(""+PortClient);
				Remember.setState(check);
			}
			catch(Exception NDA){}
	
			R.add(IpServer);			
			R.add(PortS);
			R.add(PortC);
			R.add(Remember);
			
			checkBox chk		= new checkBox();
			Remember.addItemListener(chk);
			
			BotaoAtualizar	= new JButton("Atualizar", iconeSalvar);
			BotaoFechar	= new JButton("Fechar", iconClose);
			jButtons.add(BotaoAtualizar);
			jButtons.add(BotaoFechar);
			
			ButtonHandler handler = new ButtonHandler();
			BotaoAtualizar.addActionListener(handler);
			BotaoFechar.addActionListener(handler);
		
			
			jPanel.add(labelOptions, BorderLayout.PAGE_START);
			jPanel.add(L, BorderLayout.LINE_START);
			jPanel.add(R, BorderLayout.CENTER);
			jPanel.add(jButtons, BorderLayout.PAGE_END);
			
			jFrame.getContentPane().add(jPanel);
			jFrame.setTitle("OpenChat - Opcoes");
			jFrame.setResizable(false);
			jFrame.setLocation(377,321);
			jFrame.setSize(270,135);
			jFrame.setVisible(true);
			jFrame.show();
			jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		}
		public class checkBox implements ItemListener{
			public void itemStateChanged(ItemEvent event)
			{
				check=Remember.getState();
			}
		}
		
		public class ButtonHandler implements ActionListener
		{
			public void actionPerformed(ActionEvent E)
			{
				if(E.getActionCommand().equals("Atualizar"))
				{
					HostServer = IpServer.getText();
					PortServer = Integer.parseInt(new String (""+PortS.getText()));
					PortClient = Integer.parseInt(new String (""+PortC.getText()));
					JOptionPane.showMessageDialog(null,"As opcoes foram salvas ! ( config.opc )");
					setVisible(true);
					jFrame.dispose();
										
				}
				if(E.getActionCommand().equals("Fechar"))
				{
					setVisible(true);
					jFrame.dispose();
				}
			}
		}
	}
	
	public void EscreveArquivo(String Text)
	{
		boolean op = false;
		
		try
		{
			File file		= new File("openchat/cliente/config.opc");
			FileWriter fWriter	= new FileWriter(file, op);
			BufferedWriter out	= new BufferedWriter(fWriter);

			out.write(Text);
			out.write('\r');
			out.write('\n');
			
			out.close();
		}
		catch (IOException e)
		{
			System.out.println("Erro: " + e.getMessage());
		}
		catch (SecurityException se)
		{
			System.out.println("Erro: " + se.getMessage());
		}
	}	

	public boolean ReadFile()
	{
		boolean ok=false;
			
		try
		{
			File usr 		= new File("openchat/cliente/config.opc");
			FileReader file		= new FileReader(usr);
			BufferedReader buffer	= new BufferedReader(file);
			this.HostServer		= buffer.readLine();
			this.PortServer		= Integer.parseInt(buffer.readLine());
			this.PortClient		= Integer.parseInt(buffer.readLine());
			this.LastId		= Integer.parseInt(buffer.readLine());
			ok=true;
			buffer.close();
		}
		catch(IOException File)
		{
			System.out.println("Erro :" + File.getMessage());
			ok=false;
		}
		return ok;
	}
			
}

class NewUser extends Thread
{
	
	private JFrame jFrame;
	private JLabel LNewUser, Label_Login, Label_Name, Label_Email, Label_City, Label_Info, Label_Password, Label_CCPassword, Label_FraseSecreta;
	private JTextField Login, Name, Email, City, FraseSecreta, Info;
	private JPasswordField Senha, CCSenha;
	private JButton Cadastrar, Cancelar;
	private int UsuarioID, PortServer,PortClient;
	private String UsuarioSenha, HostServer, Title;
		
	static ImageIcon iconSend 	= new ImageIcon("icons/ok.png");
	static ImageIcon iconCancel	= new ImageIcon("icons/cancel.png");
	
	public NewUser(String HS, int PS, int PC)
	{
		this.HostServer = HS;
		this.PortServer = PS;
		this.PortClient = PC;
	}
	
	public void run()
	{
		jFrame = new JFrame();
		JPanel Register = new JPanel();
		JPanel L	= new JPanel();
		JPanel R = new JPanel();
		JPanel E = new JPanel();
		
		Register.setLayout(new BorderLayout());
		L.setLayout(new GridLayout(8,1));
		R.setLayout(new GridLayout(8,1));
		E.setLayout(new GridLayout(1,2));
		
		Register.add(L,BorderLayout.LINE_START);
		Register.add(R,BorderLayout.CENTER);
		Register.add(E,BorderLayout.PAGE_END);
		
		LNewUser = new JLabel("NOVO USUARIO",JLabel.CENTER);
		Register.add(LNewUser,BorderLayout.PAGE_START);
		
		Label_Login	= new JLabel(" Apelido",JLabel.LEFT);
		Label_Name	= new JLabel (" Nome",JLabel.LEFT);
		Label_Email	= new JLabel(" Email",JLabel.LEFT);
		Label_City	= new JLabel (" Cidade",JLabel.LEFT);
		Label_Info	= new JLabel (" Infomacoes",JLabel.LEFT);
		Label_Password	= new JLabel(" Senha  ",JLabel.LEFT);
		Label_CCPassword= new JLabel(" Confirmacao da Senha  ",JLabel.LEFT);
		Label_FraseSecreta =  new JLabel(" Frase secreta:  ",JLabel.LEFT);
		
		Login 	= new JTextField(20);
		Email 	= new JTextField(50);
		City 	= new JTextField(30);
		Name 	= new JTextField(100);
		FraseSecreta = new JTextField(100);
		Info = new JTextField(200);
		Senha 	= new JPasswordField();
		CCSenha	= new JPasswordField();
		
		Name.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=Name.getText().length();
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});	
		
		Login.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=Login.getText().length();
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});	
		
		Senha.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=Senha.getPassword().length;
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});	
		CCSenha.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=CCSenha.getPassword().length;
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});
		Email.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=Email.getText().length();
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});		
		City.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=City.getText().length();
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});		
		FraseSecreta.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=FraseSecreta.getText().length();
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});
		Info.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				int i=Info.getText().length();
				char c = e.getKeyChar();      
				if (((i>25))) {
					e.consume();
				} else
					i++;
			}
		});
		
		Cadastrar = new JButton("Cadastrar", iconSend);
		Cancelar  = new JButton("Cancelar", iconCancel);
		
		L.add(Label_Login);
		L.add(Label_Password);
		L.add(Label_CCPassword);
		L.add(Label_Name);
		L.add(Label_Email);
		L.add(Label_City);
		L.add(Label_FraseSecreta);
		L.add(Label_Info);
				
		R.add(Login);
		R.add(Senha);
		R.add(CCSenha);
		R.add(Name);
		R.add(Email);
		R.add(City);
		R.add(FraseSecreta);
		R.add(Info);
		
		E.add(Cadastrar);
		E.add(Cancelar);
		
		ButtonHandler handler = new ButtonHandler(HostServer,PortServer);
		Cadastrar.addActionListener(handler);
		Cancelar.addActionListener(handler);
				
		jFrame.getContentPane().add(Register);
		
		jFrame.setTitle("Novo Usuario");
		jFrame.setResizable(true);
		jFrame.setLocation(312,289);
		jFrame.setSize(400, 225);
		jFrame.setVisible(true);
		jFrame.show();
		jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
}
	
	public class ButtonHandler implements ActionListener
	{
		String HostServer, Token, Message;
		int PortServer;
		
		public ButtonHandler(String Host, int Port)
		{
			this.HostServer	= Host;
			this.PortServer	= Port;
		}
		/*
		 * Funcao para validacao dos campos na tela de cadastro
		 */
		private boolean VerificaCampos()
		{
			boolean resul = true;
			if(Login.getText().length()==0)
				resul=false;
			if(Email.getText().length()==0)
				resul=false;
			if(Name.getText().length()==0)
				resul=false;
			if(City.getText().length()==0)
				resul=false;
			if(Info.getText().length()==0)
				resul=false;
			if(FraseSecreta.getText().length()==0)
				resul=false;
			if(new String(Senha.getPassword()).length()==0)
				resul=false;
			if (!(new String(Senha.getPassword()) ).equals(new String(CCSenha.getPassword())))
			{
				JOptionPane.showMessageDialog(null,"As senhas nao conferem!");
				resul=false;
			}
			return resul;
		}
			
		public void actionPerformed(ActionEvent E)
		{
			String Token="~~~~~~~~~~~~~~~",Message;
			
			if(E.getActionCommand().equals("Cadastrar"))
			{
				try
				{
					if(!VerificaCampos())
					{
						JOptionPane.showMessageDialog(null,"Por favor, confira os dados!");
						return;
					}
					
					Socket MSG = new Socket(HostServer,PortServer);
					BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
					PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
					
					try
					{
						String pass = new String(Senha.getPassword());
						Message = "NewUser"+Token+
								Login.getText()+Token+
								Email.getText()+Token+
								Name.getText()+Token+
								pass+Token+
								City.getText()+Token+
								FraseSecreta.getText()+Token+
								Info.getText()+Token;
					}
					catch(Exception M)
					{
						JOptionPane.showMessageDialog(null,"Falha ao reunir informacoes do novo usuario/"+M.getMessage());
						return;
					}
					
					try
					{
						Send.println(Message);
						Send.flush();
					}
				
					catch(Exception S)
					{
						JOptionPane.showMessageDialog(null,"Falha ao enviar o cadastro\n Verifique o servidor");
						return;
					}
					
					try
					{
						String id = Reply.readLine();
						jFrame.setVisible(false);
						JOptionPane.showMessageDialog(null,"\nUsuario Criado, ID: "+id+"\n");
						jFrame.dispose();
						LoginUsuario L = new LoginUsuario(Integer.parseInt(id));
						L.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
					}
					catch(Exception Insert)
					{
						JOptionPane.showMessageDialog(null,"Erro ao inserir");
					}
					
					Reply.close();
					Send.close();
					Send = null;
					MSG.close();
					MSG = null;
					
				}
				catch(Exception SOCKET)
				{
					JOptionPane.showMessageDialog(null,"Falha na conexao ao servidor: [ "+HostServer+" : "+PortServer+" ]");
				}
			}
			
			if(E.getActionCommand().equals("Cancelar"))
			{
				LoginUsuario L = new LoginUsuario(0);
				jFrame.dispose();
				
			}
		}
	}
}


class ClientMain extends Thread
{
	private JPopupMenu	popupUsuarios;
	private JFrame jFrame;
	private JButton InformacoesUsuario, SearchUser, LabelOnline;
	private JLabel LabelLastAccess;
	private JPanel Main, Buttons, LIST, USERS;
	private JScrollPane UsersScroll;
	private JComboBox jComboStatus;
	
	private String HostServer, Token="~~~~~~~~~~~~~~~", UsuarioSenha, UsuarioLogin;
	private int PortServer, PortClient, UsuarioID, STATUS=0;
	
	private Socket MSG;
	private BufferedReader Reply;
	private PrintWriter Send;
	
	private MOUSEClick MOUSE;
	private MouseListener mouseListener;
		
	private Vector  ContactListId	= new Vector(),
			ContactListLogin= new Vector(),
			ContactListIp	= new Vector(),
			MessageList	= new Vector();
				
		
	static ImageIcon iconOnline	= new ImageIcon("icons/online.png");
	static ImageIcon iconOffline	= new ImageIcon("icons/offline.png");
	static ImageIcon iconMessage	= new ImageIcon("icons/message.png");
	static ImageIcon iconFind	= new ImageIcon("icons/url.png");
	static ImageIcon iconInfo	= new ImageIcon("icons/infouser.png");
	static ImageIcon iconAdd	= new ImageIcon("icons/usuario.png");
	static ImageIcon iconRem	= new ImageIcon("icons/remover.png");
	static ImageIcon iconSearch	= new ImageIcon("icons/busca.png");
	static ImageIcon iconMy		= new ImageIcon("icons/editar.png");
	static ImageIcon iconAbout	= new ImageIcon("icons/sobre.png");
	static ImageIcon iconExit	= new ImageIcon("icons/sair.png");
	static ImageIcon iconSend	= new ImageIcon("icons/ok.png");
	static ImageIcon iconClose	= new ImageIcon("icons/cancel.png");
	
	public ClientMain(String HS, int PS, int PC, int Id, String login, String UsuarioSenha)
	{
		this.HostServer	= new String(HS);
		this.PortServer = PS;
		this.PortClient	= PC;
		this.UsuarioID	= Id;
		this.UsuarioLogin =  login;
		this.UsuarioSenha = UsuarioSenha;
	}
	
	public void run()
	{
		jFrame =  new JFrame();
		
		Main = new JPanel(new BorderLayout());
		Buttons = new JPanel(new GridLayout(3,1));
						
		LIST = new JPanel(new GridLayout(0, 1, 0, 5));
		USERS = new JPanel(new BorderLayout(2,5));
		
		USERS.add(LIST,BorderLayout.PAGE_START);
					
		UsersScroll = new JScrollPane(LIST);
		UsersScroll.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
		USERS.add("North", LIST);
		USERS.setToolTipText("Procure um amigo cadastrado na rede OpenChat.");
		MOUSE = new MOUSEClick();
		GetListContact();	//get contact list, if 1 get online users, 0 get all users
		
		LabelOnline = new JButton("Todos");
		LabelLastAccess = new JLabel("");
		LabelOnline.setIcon(iconAdd);
		
		SearchUser = new JButton("Procurar usuario", iconSearch);
		InformacoesUsuario = new JButton("Info Usuario", iconInfo);
	
		String jStatus[] = { "Todos", "Online", "Offline"};
		jComboStatus = new JComboBox(jStatus);
		
		jComboStatus.addItemListener(new ItemListener()
		{
			public void itemStateChanged(ItemEvent StatusEvent)
			{
				if(StatusEvent.getStateChange()==ItemEvent.SELECTED)
				{
					STATUS = jComboStatus.getSelectedIndex();
					switch(STATUS) {
						case 0: {
							LabelOnline.setText("Todos");
							LabelOnline.setIcon(iconAdd);
							break;
						}
						case 1: {
							LabelOnline.setText("Online");
							LabelOnline.setIcon(iconOnline);
							break;
						}
						case 2: {
							LabelOnline.setText("Offline");
							LabelOnline.setIcon(iconOffline);
							break;
						}
					}
					GetListContact();
				}
			}
		}
		);
		// Tooltips - Dicas
		SearchUser.setToolTipText("Procure um amigo cadastrado na rede OpenChat.");
		InformacoesUsuario.setToolTipText("Informacoes sobre o usuario (Nome, Email, Cidade, etc).");

		// Handlers dos Botões
		Buttons.add(jComboStatus);		
		Buttons.add(InformacoesUsuario);
		Buttons.add(SearchUser);
		
		ButtonHandler handler = new ButtonHandler();
		InformacoesUsuario.addActionListener(handler);
		SearchUser.addActionListener(handler);
				
		JMenu Menu = new JMenu("Opcoes");
		Menu.setMnemonic('O');
		
		JMenu Exit = new JMenu("Sair");
		Menu.setMnemonic('E');

		JMenuItem AddContact = new JMenuItem("Adicionar Contato",iconAdd);
		JMenuItem RemContact = new JMenuItem("Remover Contato", iconRem);
		JMenuItem InformacoesUsuarioM = new JMenuItem("Info Usuario", iconInfo);
		JMenuItem SearchUser = new JMenuItem("Procurar usuario", iconSearch);
		JMenuItem MyInfo = new JMenuItem("Meus Dados", iconMy);
		JMenuItem About = new JMenuItem("Sobre", iconAbout);
		JMenuItem exit = new JMenuItem("Sair", iconExit);
		//JMenuItem Logout = new JMenuItem("Logout");
				
		//Exit.add(Logout);
		Exit.addSeparator();
		Exit.add(exit);
		
		Menu.add(AddContact);
		Menu.add(RemContact);
		Menu.add(InformacoesUsuarioM);
		Menu.add(SearchUser);
		Menu.addSeparator();
		Menu.add(MyInfo);
		Menu.addSeparator();
		Menu.add(About);
		
		ClickMenuItems clickMenu = new ClickMenuItems();
		
		InformacoesUsuarioM.addActionListener(clickMenu);
		exit.addActionListener(clickMenu);
		AddContact.addActionListener(clickMenu);
		RemContact.addActionListener(clickMenu);
		SearchUser.addActionListener(clickMenu);
		About.addActionListener(clickMenu);
		MyInfo.addActionListener(clickMenu);
		
		JMenuBar bar = new JMenuBar();
		jFrame.setJMenuBar(bar);
		
		bar.add(Menu);
		bar.add(Exit);
		
		Main.add(LabelOnline,BorderLayout.PAGE_START);
		Main.add(new JScrollPane(USERS),BorderLayout.CENTER);
		Main.add(Buttons,BorderLayout.PAGE_END);
				
		jFrame.getContentPane().add(Main);
			
		jFrame.setTitle(UsuarioID+" - OpenChat");
		jFrame.setLocation(844,132);
		jFrame.setSize(170,500);
		jFrame.setVisible(true);
		jFrame.show();
				
		jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		//jFrame.setDefaultLookAndFeelDecorated(true);
		new StartInbox(PortClient).start();
	}
		
	public String ContatoUsuario(String option, int Contact)
	{
		String Cont="false";
		try
		{
			MSG = new Socket(HostServer,PortServer);
			Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
			Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
			
			Send.println(option+Token+UsuarioID+Token+Contact+Token);
			Send.flush();
			
			Cont =  Reply.readLine();
			
			Send.close();
			Reply.close();
			MSG.close();
		}				
		catch(Exception Exit)
		{
			JOptionPane.showMessageDialog(null,"Server down!\n\n"+Exit.getMessage());
		}
		return Cont;
	}
	
	public void Logout()
	{
		try
		{
			MSG = new Socket(HostServer,PortServer);
			Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
			
			Send.println("Logout"+Token+UsuarioID+Token+UsuarioSenha+Token);
			Send.flush();
			MSG.close();
			Send.close();
			
			ContactListId.clear();
			ContactListLogin.clear();
			ContactListIp.clear();
			LIST.removeAll();
			LIST.revalidate();
			
		}				
		catch(Exception Exit)
		{
			JOptionPane.showMessageDialog(null,"Erro :: O servidor esta fora do ar ou a senha esta incorreta.\n\n"+Exit.getMessage());
		}
	}
	
	public class ClickMenuItems implements ActionListener
	{
			public void actionPerformed(ActionEvent E)
			{
				if(E.getActionCommand().equals("Sobre"))
				{
					About A = new About();
				}
					
				if(E.getActionCommand().equals("Logout"))
				{
					Logout();
				}
					
				if(E.getActionCommand().equals("Sair"))
				{
					Logout();
					System.exit(0);
				}
				if(E.getActionCommand().equals("Meus Dados"))
				{
					boolean op=true;
					new InformacoesUsuario(HostServer, PortServer, ""+UsuarioID,op).start();
				}
				if(E.getActionCommand().equals("Info Usuario"))
				{
					if(LabelLastAccess.getText().equals(""))
					{
						JOptionPane.showMessageDialog(null,"\nSelecione o usuario.");
					}
						else
					for(int i=0; i < ContactListId.size(); i++)
					{
						
						if(ContactListLogin.get(i).equals(LabelLastAccess.getText()))
						{
							boolean op=false;
							new InformacoesUsuario(HostServer, PortServer, ""+ContactListId.get(i),op).start();
							break;
						}
					}
				}
				if(E.getActionCommand().equals("Adicionar Contato"))
				{
					int NewUser=0;
					try	{
						String test = JOptionPane.showInputDialog("Qual e' o ID do novo Contato");
						if(test==null)
							return;
						else
							NewUser = Integer.parseInt(test);
					}
					catch(Exception NEWUSER) {
						JOptionPane.showMessageDialog(null,"\nO Valor do ID invalido. (apenas inteiros)\n");
						return;
					}
					
					if(ContatoUsuario("AddContact",NewUser).equals("true") && NewUser != UsuarioID)
					{
						JOptionPane.showMessageDialog(null,"\n Usuario Adicionado !");
						GetListContact();
					}
					else
						JOptionPane.showMessageDialog(null,"\n Voce nao pode adcionar a si mesmo na lista");
				}
				
				if(E.getActionCommand().equals("Remover Contato"))
				{
					int RemUser=0, ConfirmRem=0;
					
					if(LabelLastAccess.getText().equals(""))
					{
						JOptionPane.showMessageDialog(null,"\nSelecione o Contato.");
					}
					else
					{
						RemUser = JOptionPane.showConfirmDialog((Component)null, "Remover o Usuario :  "+ LabelLastAccess.getText(), "Remo�o de Usuario - OpenChat", JOptionPane.YES_NO_OPTION);
						
						if(RemUser!=1)
						{
							for (int i=0; i < ContactListLogin.size(); i++)
							{
								if ((LabelLastAccess.getText()).equals(ContactListLogin.get(i)))
								{
									RemUser=Integer.parseInt(""+ContactListId.get(i));
									break;
								}
							}

							if(ContatoUsuario("DeleteContact",RemUser).equals("true"))
							{
								JOptionPane.showMessageDialog(null,"\n Usuario Removido !");
								GetListContact();
								LabelLastAccess.setText("");
							}
							else
								JOptionPane.showMessageDialog(null,"\n Contato: \n    - Nao Encontrado\n    - Contato");
						}
					}
				}
				if(E.getActionCommand().equals("Procurar usuario"))
					new SearchUsers().start();
			}
	}
		
	private void GetListContact()
	{
		// Cria o menu popup quando se clica no nome dos usuários
		JMenuItem popupItemInfo = new JMenuItem("Info usuario",iconInfo);
		JMenuItem popupItemDel = new JMenuItem("Remover usuario",iconRem);
		JMenuItem popupItemEnv = new JMenuItem("Enviar Mensagem",iconMessage);
		popupUsuarios = new JPopupMenu("Menu");
		popupUsuarios.add(popupItemInfo);
		popupUsuarios.add(popupItemDel);
		popupUsuarios.add(popupItemEnv);
		popupMenuItens clickPopupMenu = new popupMenuItens();
		popupItemDel.addActionListener(clickPopupMenu);
		popupItemInfo.addActionListener(clickPopupMenu);
		popupItemEnv.addActionListener(clickPopupMenu);

		StringTokenizer CONTACT;
		try
		{
			MSG = new Socket(HostServer,PortServer);
			Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
			Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
		
			String Message = "ReturnContactList"+Token+UsuarioID;
				
			Send.println(Message);
			Send.flush();
				
			CONTACT = new StringTokenizer(Reply.readLine(), Token);
			
			MSG.close();
			MSG=null;
			Reply.close();
			Reply=null;
			Send.close();
			Send=null;
			
			if(CONTACT.nextToken().equals("contatoList"))
			try
			{				
				ContactListId.clear();
				ContactListLogin.clear();
				ContactListIp.clear();
				
				ContactListIp.removeAllElements();
				ContactListLogin.removeAllElements();
				ContactListId.removeAllElements();
				
				LIST.removeAll();
				LIST.revalidate();
				
				String LOGIN, ID, Ip;
				
				while(CONTACT.hasMoreTokens())
				{
					ID = new String(CONTACT.nextToken());
					LOGIN = new String(CONTACT.nextToken());
					Ip = new String(CONTACT.nextToken());
					CONTACT.nextToken(); //not port
					ContactListId.addElement(ID);
					ContactListLogin.addElement(LOGIN);
					ContactListIp.addElement(Ip);
					if(STATUS==1 || STATUS==0)
					if(! Ip.equals("0")) //online
					{
						JLabel label = new JLabel(LOGIN, iconOnline, JLabel.LEFT);
						LIST.add("Center",label);
						label.addMouseListener(MOUSE);
						label.addMouseListener(mouseListener);
					}
					
					if(STATUS==2 || STATUS==0)
					if(Ip.equals("0")) //offline
					{							
						JLabel label = new JLabel(LOGIN, iconOffline, JLabel.LEFT);
						label.addMouseListener(MOUSE);
						label.addMouseListener(mouseListener);
						LIST.add("Center",label);
					}
				}
			}
			catch(Exception E)
			{
				JOptionPane.showMessageDialog(null,"Error in ContactList.\n\n"+E.getMessage());
				return;
			}
		}
		catch(Exception E)
		{
			JOptionPane.showMessageDialog(null,"Error in ContactList.\n\n"+E.getMessage());
			return;
		}
		
	}
	class MOUSEClick extends MouseAdapter
	{
		/* Aqui vamos fazer o tratamento dos cliques do mouse
		* e assim descobrir se a pessoa "tentou" chamar um popup
		* ou se ela só clicou no nick de alguem
		*/
		public void mousePressed(MouseEvent e) {
			maybeShowPopup(e);
		}
		private void maybeShowPopup(MouseEvent e) {
			if (e.isPopupTrigger()) {
				JLabel pressedLabel = (JLabel) e.getComponent();
				LabelLastAccess = pressedLabel;
				popupUsuarios.show(e.getComponent(),e.getX(),e.getY());
			}
		} 
		public void mouseClicked(MouseEvent e) 
		{
			if (!LabelLastAccess.equals("")) {
				LabelLastAccess.setForeground(Color.BLACK);
			}
			
			JLabel pressedLabel = (JLabel) e.getComponent();
			LabelLastAccess = pressedLabel;
			//System.out.println(pressedLabel.getComponent());
			
			String PoupMessage = new String("");
			int IdFROM=0;
			
			// essa parte aqui �bugada, pois se tiver 2 contatos com o mesmo nome, ele vai pegar o primeiro da lista
			// msm pesquisando no site da sun e em grupos nao consegui resolver isso
			// deve haver uma maneira mais inteligente, alias, existe, porem eu nao sei 
			for (int i=0; i < ContactListLogin.size(); i++)
			//for (int i=0; i < LIST.gmponentCount(); i++)
			{
				if (pressedLabel.getText().equals(ContactListLogin.get(i)) && e.getClickCount() == 2)
				//if (ContactListLogin.get(i) && e.getClickCount() == 2)
				{
					if(pressedLabel.getIcon()==iconMessage)
					{
						pressedLabel.setIcon(iconOnline);
						
						for(int k=0; k < MessageList.size(); k++)
						for(int j=0; j < MessageList.size(); j++)
						{
							if( ("MessageTo"+Token+ContactListId.get(i)).equals(MessageList.get(j)))
							{
								IdFROM = i;
								MessageList.removeElementAt(j);
								PoupMessage = PoupMessage+MessageList.get(j)+Token;
								MessageList.removeElementAt(j);
								k=0;
								break;
								
							}					
						}
						new MsgBoxReceive(HostServer, PortServer, UsuarioID, Integer.parseInt(""+ContactListId.get(IdFROM)),""+ContactListLogin.get(IdFROM),""+ContactListIp.get(IdFROM),PoupMessage).start();
					}
					else
					{
						pressedLabel.setForeground(Color.BLACK);
						pressedLabel.repaint();
						new MsgBox(HostServer, PortServer, UsuarioID, UsuarioLogin, ContactListId.get(i), ContactListLogin.get(i), ContactListIp.get(i)).start();
						    
					}
					break;
				}
				else
				if(pressedLabel.getText().equals(ContactListLogin.get(i)) && e.getClickCount() == 1)
				{
					pressedLabel.setForeground(Color.BLUE);
					pressedLabel.repaint();
				}
			}
		}
	}
	/* O que acontece se você clicar em alguma opp do popup
	* A resposta está aqui! Listeners do popup!!!
	*/
	public class popupMenuItens implements ActionListener
	{
			public void actionPerformed(ActionEvent E)
			{
				if(E.getActionCommand().equals("Enviar Mensagem"))
				{
						if (!LabelLastAccess.equals("")) {
							LabelLastAccess.setForeground(Color.BLACK);
						}
			
						String PoupMessage = new String("");
						int IdFROM=0;
						
						// essa parte aqui �bugada, pois se tiver 2 contatos com o mesmo nome, ele vai pegar o primeiro da lista
						// msm pesquisando no site da sun e em grupos nao consegui resolver isso
						// deve haver uma maneira mais inteligente, alias, existe, porem eu nao sei 
						for (int i=0; i < ContactListLogin.size(); i++)
						//for (int i=0; i < LIST.getComponentCount(); i++)
						{
							new MsgBox(HostServer, PortServer, UsuarioID, UsuarioLogin, ContactListId.get(i), ContactListLogin.get(i), ContactListIp.get(i)).start();
							break;
						}				
				}
				if(E.getActionCommand().equals("Info usuario"))
				{
					if(LabelLastAccess.getText().equals(""))
					{
						JOptionPane.showMessageDialog(null,"\nSelecione o usuario.");
					}
						else
					for(int i=0; i < ContactListId.size(); i++)
					{
						
						if(ContactListLogin.get(i).equals(LabelLastAccess.getText()))
						{
							boolean op=false;
							new InformacoesUsuario(HostServer, PortServer, ""+ContactListId.get(i),op).start();
							break;
						}
					}
				}
				if(E.getActionCommand().equals("Remover usuario"))
				{
					int RemUser=0, ConfirmRem=0;
					RemUser = JOptionPane.showConfirmDialog((Component)null, "Remover o Usuário :  "+ LabelLastAccess.getText(), "Remoção de Usuário - OpenChat", JOptionPane.YES_NO_OPTION);
					if(RemUser!=1)
					{
						for (int i=0; i < ContactListLogin.size(); i++)
							{
								if ((LabelLastAccess.getText()).equals(ContactListLogin.get(i)))
								{
									RemUser=Integer.parseInt(""+ContactListId.get(i));
									break;
								}
							}
							if(ContatoUsuario("DeleteContact",RemUser).equals("true"))
							{
								JOptionPane.showMessageDialog(null,"\n Usuario Removido !");
								GetListContact();
								LabelLastAccess.setText("");
							}
							else
								JOptionPane.showMessageDialog(null,"\n Contato: \n    - Nao Encontrado\n    - Contato");
						}
					}
			}
	}
	
	
	class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Info Usuario"))
			if(ContactListId.size() > 0)
			{
				if(LabelLastAccess.getText().equals(""))
				{
					JOptionPane.showMessageDialog(null,"\nSelecione o usuario para obter informacoes");
					
				}
				else
				for(int i=0; i < ContactListId.size(); i++)
				{
					if(ContactListLogin.get(i).equals(LabelLastAccess.getText()))
					{
						boolean op=false;
						new InformacoesUsuario(HostServer, PortServer, ""+ContactListId.get(i),op).start();
						break;
					}
				}
					
			}else
				JOptionPane.showMessageDialog(null,"\nNenhum usuario na lista!");
			
			if(E.getActionCommand().equals("Procurar usuario"))
			{
				new SearchUsers().start();
			}	
		}
	}

	class StartInbox extends Thread
	{
		private ServerSocket ServerMessage;
		private Socket Inbox;
		private StringTokenizer MSG;
		private BufferedReader E;
		private String Confirm;
		private int IdFrom, PortClient;
		private ClientMain clientMain;
		
		public StartInbox(int PortClient)
		{
			this.PortClient = PortClient;
		}
		public void run()
		{
      for(;PortClient < 60000; PortClient++) {
        try {
			ServerMessage = new ServerSocket(PortClient);
			break;
        }
        catch(IOException E) {
        }
      }
			atualizaIP();
			try {
				for(;;) {
					Inbox = ServerMessage.accept();
					NewMessage(Inbox);
				}
			}
			catch(IOException ExpStartServer) {
				System.err.println("Falha ao iniciar o servidor de mensagem");
				System.err.println(ExpStartServer.getMessage());
			}
		}			
		
		private void atualizaIP()
		{
			try {
				Socket MSG2 = new Socket(HostServer, PortServer);
				BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG2.getInputStream()));
				PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG2.getOutputStream()));
				String msg = "UpdateUserPort"+Token+IdFrom+Token+PortClient;
				Send.println(msg);
				Send.flush();
				Send.close();
			}
			catch(IOException E) {
				System.err.println("Falha ao atualizar a porta do cliente");
				System.err.println(E.getMessage());
			}
		}
	
		private void NewMessage(Socket New)
		{
			try
			{
				JLabel LabelUser = new JLabel();
				
				this.Inbox = New;
				E = new BufferedReader (new InputStreamReader (this.Inbox.getInputStream()));
				MSG = new StringTokenizer (E.readLine (),"~~~~~~~~~~~~~~~");
			
				Confirm = new String(MSG.nextToken());
				
				if(Confirm.equals("List"))
					GetListContact();
				
				if(Confirm.equals("NewMessage"))
				{
					IdFrom = Integer.parseInt(MSG.nextToken());
					String Msg = "";
					try{
					for (;;)
					{
						Msg = Msg + E.readLine();
						if(E.ready())
							Msg = Msg + '\n';
						else
							break; // caso nao existam, sair do loop de montagem da mensagem
					}
				}
					catch(Exception E)
					{
						System.out.println("Falha ao receber mensagem: "+E.getMessage());
					}
				
					//System.out.println("CLIENT :: "+Msg);
					int flag=0;
					for(int i=0; i< LIST.getComponentCount(); i++)
					{
						if(Integer.parseInt(""+ContactListId.get(i))==IdFrom)
						{
							LabelUser = (JLabel) LIST.getComponent(i);
							LabelUser.setForeground(Color.BLUE);
							LabelUser.repaint();
							LabelUser.setIcon(iconMessage);
													
							MessageList.addElement("MessageTo"+Token+IdFrom);
							MessageList.addElement(Msg);
							flag=1;
							break;
						}
					}
					if(flag==0)
						new MsgBoxReceive(HostServer, PortServer, UsuarioID, IdFrom, new String(""+IdFrom), Inbox.getInetAddress().getHostAddress(), Msg).start();
				}
			}
			catch(Exception E)
			{
				System.out.println("errrooooo");
				System.out.println(E.getMessage());
			}
			
			try
			{
				E.close ();
				Inbox.close ();
			}
			catch(Exception E)
			{
				System.out.println("erro ao close do client");
        System.out.println(E.getMessage());
			}
		}
	}
	
	class SearchUsers extends Thread
	{
		private JFrame jFrame;
		private JPanel jPanel, jButtons, jLists, jLabels;
		private JButton ButtonSearch, ButtonClose, ButtonAdd;
		private JLabel LabelId, LabelLogin, LabelIp, LabelSearch;
		private JList ListId, ListLogin, ListIp;
		private JComboBox ComboSearchFor;
		
		private String jComboSearchOptions[] = { "Usuarios Online", "Todos os Usuarios"}, Token="~~~~~~~~~~~~~~~";
		private StringTokenizer UsersFound;
		private int OptionSearch;
			
		private Vector UsuarioIDFound, LoginUsuarioFound, UserIpFound;
				
		public void run()
		{
			jFrame = new JFrame();
			
			jPanel = new JPanel(new BorderLayout());
			jLists = new JPanel(new GridLayout(1,3));
			jButtons = new JPanel( new GridLayout(1,3));
			jLabels = new JPanel(new GridLayout(2,3));
		
			ButtonSearch = new JButton("Procurar agora", iconSearch);
			ButtonClose = new JButton("Fechar", iconClose);
			ButtonAdd = new JButton("Adicionar a lista", iconAdd);
			jButtons.add(ButtonSearch);
			jButtons.add(ButtonAdd);
			jButtons.add(ButtonClose);
			// Tooltips - Dicas
			ButtonSearch.setToolTipText("Busca por alguem na rede OpenChat.");
			ButtonAdd.setToolTipText("Adicione o usuario na sua lista de contatos e\n Comece a conversar.");

			// Handlers dos botões
			ButtonClickSearch Search = new ButtonClickSearch();
			ButtonSearch.addActionListener(Search);
			ButtonClose.addActionListener(Search);
			ButtonAdd.addActionListener(Search);
			
			
			ComboSearchFor = new JComboBox(jComboSearchOptions);
			
			ComboSearchFor.addItemListener(new ItemListener()
			{
				public void itemStateChanged(ItemEvent StatusEvent)
				{
					if(StatusEvent.getStateChange()==ItemEvent.SELECTED)
						OptionSearch = ComboSearchFor.getSelectedIndex();
				}
			}
			);
		
			LabelSearch = new JLabel("Busca de Usuario", JLabel.CENTER);
			LabelSearch.setForeground(Color.BLUE);
			LabelId = new JLabel("  Id  ( selecione aqui )");
			LabelLogin = new JLabel("  Apelido");
			LabelIp = new JLabel("  Ip");
			
						
			jLabels.add(new JLabel(""));
			jLabels.add(LabelSearch);
			jLabels.add(ComboSearchFor);
			
			jLabels.add(LabelId);
			jLabels.add(LabelLogin);
			jLabels.add(LabelIp);
			
			ListId = new JList();
			ListLogin = new JList();
			ListIp = new JList();
			jLists.add(ListId);
			jLists.add(ListLogin);
			jLists.add(ListIp);
			
			ItemSelect itemSelect = new ItemSelect();
			
			ListId.addListSelectionListener(itemSelect);
			ListIp.addListSelectionListener(itemSelect);
			ListLogin.addListSelectionListener(itemSelect);
			
			
			jPanel.add(jLabels,BorderLayout.PAGE_START);
			jPanel.add(new JScrollPane(jLists),BorderLayout.CENTER);
			jPanel.add(jButtons,BorderLayout.PAGE_END);
			
			jFrame.getContentPane().add(jPanel);
		
			jFrame.setTitle("Buscar por Usuarios - OpenChat");
			jFrame.setLocation(200,259);
			jFrame.setSize(600,250);
			jFrame.setVisible(true);
			jFrame.show();
			jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		}
		
		class ItemSelect implements ListSelectionListener
		{
			public void valueChanged(ListSelectionEvent EventList)
			{
				if(!ListId.isSelectionEmpty())
				{
					ListLogin.setSelectedIndex(ListId.getSelectedIndex());
					ListIp.setSelectedIndex(ListId.getSelectedIndex());
				}
				else
				if(!ListLogin.isSelectionEmpty() || !ListIp.isSelectionEmpty())
				{
					ListLogin.clearSelection();
					ListIp.clearSelection();
				}
			}
		}
		
		
		class ButtonClickSearch implements ActionListener
		{
			public void actionPerformed(ActionEvent ESearch)
			{
				if(ESearch.getActionCommand().equals("Procurar agora"))
				{
					SearchNowUsers();
				}
				if(ESearch.getActionCommand().equals("Fechar"))
					jFrame.dispose();
				
				if(ESearch.getActionCommand().equals("Adicionar a lista"))
				{
					if(ListId.isSelectionEmpty())
						JOptionPane.showMessageDialog(null,"\n Selecione o ID do usuario.");
					else
					if(Integer.parseInt(""+UsuarioIDFound.get(ListId.getSelectedIndex())) == UsuarioID)
						JOptionPane.showMessageDialog(null,"\n Voce nao pode adcionar a si mesmo na lista");
					else
					if(ContatoUsuario("AddContact",Integer.parseInt(""+UsuarioIDFound.get(ListId.getSelectedIndex()))).equals("true"))
					{
						JOptionPane.showMessageDialog(null,"\n Contato adicionado com sucesso !");
						GetListContact();
					}
					else
						JOptionPane.showMessageDialog(null,"\n O contato ja existe na sua lista.");
				}
			}
		}
		
		private void SearchNowUsers()
		{
			try
			{
				MSG = new Socket(HostServer,PortServer);
				Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
				Send = new PrintWriter (new OutputStreamWriter(MSG.getOutputStream()));
			
			try
			{
				String M = "ReturnUsers"+Token+OptionSearch+Token;
				Send.println(M);
				Send.flush();
				
				UsersFound = new StringTokenizer(Reply.readLine(), Token);
				
				UsuarioIDFound = new Vector();
				UserIpFound = new Vector();
				LoginUsuarioFound = new Vector();
				
				UsersFound.nextToken();
				
				String U,I,L;
				boolean TemUsuarios=false;
				while (UsersFound.hasMoreTokens())
				{
					U=new String(UsersFound.nextToken());
					L=new String(UsersFound.nextToken());
					I=new String(UsersFound.nextToken());
					UsersFound.nextToken();
					
					if(L.length() > 25)
						L = L.substring(0,25)+"...";
					
					if(UsuarioID != Integer.parseInt(U)) {
						UsuarioIDFound.addElement(U);
						LoginUsuarioFound.addElement(L);
						UserIpFound.addElement(I);
						TemUsuarios=true;
					}
				}
				if(!TemUsuarios)
					JOptionPane.showMessageDialog(null,"Nenhum usuario online no momento!");
				
				ListId.clearSelection();
				ListLogin.clearSelection();
				ListIp.clearSelection();
				ListId.setListData(UsuarioIDFound);
				ListLogin.setListData(LoginUsuarioFound);
				ListIp.setListData(UserIpFound);
			}
			catch(Exception E)
			{
				System.out.println("Erro na busca"+E.getMessage());
			}
				Reply.close();
				Send.close();
				MSG.close();
			}
			catch(Exception Ex)
			{
				JOptionPane.showMessageDialog(null,"\nErro na conexao com o servidor!\nServidor Online?","Warning",JOptionPane.WARNING_MESSAGE);
				return;
			}
			
		}
			
	}
	
	
		
}


class InformacoesUsuario extends Thread
{     
	private JPanel Register, L, R, E;
	private JButton ButtonClose, ButtonUpdate;
	private JFrame jFrame;
	private JLabel LabelInfo, Label_Id, Label_Login, Label_Name, Label_Email, Label_City, Label_Info, Label_Password_C, Label_Password, lId, Label_FraseSecreta;
	private JTextField Login, Name, Email, City, Info, Password, Password_C, fraseSecreta;
	private int Id, Port;
	private String Token="~~~~~~~~~~~~~~~", Host;
	private boolean option=false;
		
	private BufferedReader Receive;
	private PrintWriter Send;
	private Socket Msg;
	
	static ImageIcon iconUpdate = new ImageIcon("icons/ok.png");
	static ImageIcon iconClose = new ImageIcon("icons/cancel.png");
	
	public InformacoesUsuario(String Host, int Port, String Id, boolean option)
	{
		this.Id = Integer.parseInt(Id);
		this.Host = Host;
		this.Port = Port;		
		this.option=option;
		
		try
		{
			Msg = new Socket(Host,Port);
			Receive = new BufferedReader (new InputStreamReader (this.Msg.getInputStream()));
			Send = new PrintWriter (new OutputStreamWriter(this.Msg.getOutputStream()));
		}
		catch(Exception Ex)
		{
			JOptionPane.showMessageDialog(null,"\nErro na comunicacao com o servidor!\nO servidor está online?","Warning",JOptionPane.WARNING_MESSAGE);
			return;
		}
	}
	
	public void run()
	{
		jFrame = new JFrame();
		Register = new JPanel();
		L = new JPanel();
		R = new JPanel();
		E = new JPanel();
		
		Register.setLayout(new BorderLayout());
		L.setLayout(new GridLayout(9,1));
		R.setLayout(new GridLayout(9,1));
		E.setLayout(new GridLayout(1,2));
		
		Register.add(L,BorderLayout.LINE_START);
		Register.add(R,BorderLayout.CENTER);
		Register.add(E,BorderLayout.PAGE_END);
		
		LabelInfo = new JLabel("INFORMACOES DO USUARIO",JLabel.CENTER);
		LabelInfo.setForeground(Color.BLUE);
		
		Register.add(LabelInfo,BorderLayout.PAGE_START);
		
		lId = new JLabel(""+Id, JLabel.LEFT);
		Label_Id = new JLabel(" Id ",JLabel.LEFT);
		Label_Login = new JLabel(" Apelido",JLabel.LEFT);
		Label_Name = new JLabel (" Nome",JLabel.LEFT);
		Label_Email = new JLabel(" Email",JLabel.LEFT);
		Label_City = new JLabel (" Cidade",JLabel.LEFT);
		Label_Info = new JLabel (" Informaes",JLabel.LEFT);
    Label_FraseSecreta = new JLabel (" Frase Secreta",JLabel.LEFT);
		Label_Password = new JLabel(" Senha  ",JLabel.LEFT);
		Label_Password_C = new JLabel(" Confirmacao Senha ", JLabel.LEFT);
		Label_Password.setVisible(option);
				
		try{
			Send.println("ReturnUserContactInformation"+Token+Id);
		
			Send.flush();
			
			StringTokenizer Information = new StringTokenizer(Receive.readLine(),Token);

			Login = new JTextField(Information.nextToken(),20);
			Login.setEditable(option);
			Login.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=Login.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
				}
			});
		
			Email = new JTextField(Information.nextToken(),50);
			Email.setEditable(option);
			Email.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=Email.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
				}
			});
				
			City = new JTextField(Information.nextToken(),30);
			City.setEditable(option);
			City.setVisible(true);
			City.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=City.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
				}
			});
			
			Name = new JTextField(Information.nextToken(),100);
			Name.setEditable(option);
			Name.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=Name.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
				}
			});
		
			Info = new JTextField(Information.nextToken(),100);
			Info.setEditable(option);
			Info.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=Info.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
					}
			});

			fraseSecreta = new JTextField(Information.nextToken(),100);
			fraseSecreta.setEditable(option);
			fraseSecreta.setVisible(option);
			fraseSecreta.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=fraseSecreta.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
				}
			});

			Password = new JPasswordField();//E.readLine());
			Password.setVisible(option);
			Password.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=Password.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
					}
			});
			Password_C = new JPasswordField();//E.readLine());
			Password_C.setVisible(option);
			Password_C.addKeyListener(new KeyAdapter() {
				public void keyTyped(KeyEvent e) {
					int i=Password_C.getText().length();
					char c = e.getKeyChar();      
					if (((i>25))) {
						e.consume();
					} else
						i++;
				}
			});
			
			Send.close();
			Receive.close();
			Msg.close();
		}
		
		catch(IOException Ex)
		{
			JOptionPane.showMessageDialog(null,"Falha ao buscar as informaes do usurio!\n" + Ex.getMessage() ,"Warning",JOptionPane.WARNING_MESSAGE);
			System.err.println(Ex.getMessage());
			return;
		}
		
		ButtonUpdate = new JButton("Atualizar", iconUpdate);
		ButtonUpdate.setVisible(option);
		ButtonClose = new JButton("Fechar", iconClose);
		
		lId.setForeground(Color.BLUE);
		
		L.add(Label_Id);
		L.add(Label_Login);
		if(option) {
			L.add(Label_Password);
			L.add(Label_Password_C);
		}
		L.add(Label_Name);
		L.add(Label_Email);
		L.add(Label_City);
		L.add(Label_Info);
		if(option)
    L.add(Label_FraseSecreta);
		
		R.add(lId);
		R.add(Login);
		if(option) {
			R.add(Password);
			R.add(Password_C);
		}
		R.add(Name);
		R.add(Email);
		R.add(City);
		R.add(Info);
		if(option) {
    R.add(fraseSecreta);

		}
		E.add(ButtonUpdate);
		E.add(ButtonClose);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonClose.addActionListener(handler);
		ButtonUpdate.addActionListener(handler);
				
		jFrame.getContentPane().add(Register);
		
		jFrame.setTitle("Informaes do usurio - OpenChat");
		jFrame.setResizable(false);
		jFrame.setLocation(312,289);
		jFrame.setSize(400,240);
		jFrame.setVisible(true);
		jFrame.show();
		jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	}
	public class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Fechar"))
			{
				jFrame.dispose();
			}
			else
			
			if(VerificaCampos()==7)
				JOptionPane.showMessageDialog(null,"As senhas nao conferem!");
			else
			if(VerificaCampos()==0)
			{
				try{
				Socket MSG = new Socket(Host,Port);
				BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
				PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
				
				String M = "UpdateUser"+Token+Id+Token+
					Password.getText()+Token+
					Login.getText()+Token+
					Email.getText()+Token+
					Name.getText()+Token+
					City.getText()+Token+
					Info.getText()+Token+
          fraseSecreta.getText()+Token;
				Send.println(M);
				Send.flush();
				
				if(Reply.readLine().equals("true"))
				{
					JOptionPane.showMessageDialog(null,"Dados atualizados com sucesso !");
					jFrame.dispose();
				}
				MSG.close();
				Reply.close();
				Send.close();
				
				}
				catch(Exception Es)
				{}
			}
			else
				JOptionPane.showMessageDialog(null,"Falha ao atualizar os dados!\n\nFavor verificar os campos de senha e frase secreta, nao podem ser vazios!","Warning",JOptionPane.WARNING_MESSAGE);
		}
	}
	
	private int VerificaCampos()
	{
			int resul = 0;
			
			if(Login.getText().length()==0)
				resul=1;
			if(Email.getText().length()==0)
				resul=2;
			if(Name.getText().length()==0)
				resul=3;
			if(City.getText().length()==0)
				resul=4;
			if(Info.getText().length()==0)
				resul=5;
      if(fraseSecreta.getText().length()==0)
				resul=8;
			if(Password.getText().length()==0)
				resul=6;
			if (!(new String(Password.getText())).equals(new String(Password_C.getText()))) 
				resul=7;
			return resul;
	}
}

// this class send message to user
class MsgBox extends Thread
{
	private JLabel LabelStatus;
	private JButton ButtonSend, ButtonCancel;
	private JPanel jPanel, jLabel, jTop, jButtons;
	private JFrame jFrame;
	private JTextArea textArea, areaHistorico;
	private Historico historico;
	private String IpTo, LoginTo, HostServer, Token="~~~~~~~~~~~~~~~", LoginFrom;
	private int IdFrom, IdTo, PortServer;
	private JScrollBar verbar;
	static ImageIcon iconSend = new ImageIcon("icons/ok.png");
	static ImageIcon iconCancel = new ImageIcon("icons/cancel.png");
	
	public MsgBox(String HostServer, int PortServer, int IdFrom, String LoginFrom, Object IdTo, Object LoginTo, Object IpTo)
	{
		this.HostServer = HostServer;
		this.PortServer = PortServer;
		this.IdFrom = IdFrom;
		this.IdTo = Integer.parseInt(new String(""+IdTo));
		this.LoginTo = ""+LoginTo;
		this.LoginFrom = LoginFrom;
		this.IpTo = ""+IpTo;
		historico = new Historico(this.IdTo, this.LoginFrom);
	}
	
	public void run()
	{
		
		jFrame = new JFrame();
		jFrame.setTitle(LoginTo +" - OpenChat");

		jPanel = new JPanel(new BorderLayout(0,0));
		jTop = new JPanel(new BorderLayout(0,0));
    
		jLabel = new JPanel(new GridLayout(2,1));
		jButtons = new JPanel(new GridLayout(1,2));
		
		ButtonSend = new JButton("Enviar (CTRL+ENTER)", iconSend);
		ButtonCancel = new JButton("Fechar (ESC)", iconCancel);
		
		LabelStatus = new JLabel(" Mensagem para "+LoginTo+"     Id: "+IdTo+"     IP: "+IpTo);
		
		textArea = new JTextArea(5, 20);
    
		areaHistorico = new JTextArea(7, 20);
		areaHistorico.setEditable(false);
		areaHistorico.setWrapStyleWord(true);
		areaHistorico.setText(historico.listar(3));
									
		jLabel.add(LabelStatus);
    
		JScrollPane jahistorico = new JScrollPane(areaHistorico);
		verbar = jahistorico.getVerticalScrollBar();
		verbar.setMaximum(9999);
		verbar.setValue(verbar.getMaximum());

		jTop.add(jLabel, BorderLayout.PAGE_START);
		jTop.add(jahistorico, BorderLayout.CENTER);

		jButtons.add(ButtonSend);
		jButtons.add(ButtonCancel);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonSend.addActionListener(handler);
		ButtonCancel.addActionListener(handler);
    
		textArea.addKeyListener (
		  new KeyAdapter () {
			public void keyPressed (KeyEvent e)
			{ 
			  if ((e.getModifiersEx()&KeyEvent.CTRL_DOWN_MASK)==KeyEvent.CTRL_DOWN_MASK && e.getKeyCode()==KeyEvent.VK_ENTER)
				enviaMensagem();
			  
			  if ((int)e.getKeyChar () == KeyEvent.VK_ESCAPE)
				jFrame.dispose();
			}
		  }
		);

		jPanel.add(jTop, BorderLayout.PAGE_START);
		jPanel.add(new JScrollPane(textArea), BorderLayout.CENTER);
		jPanel.add(jButtons, BorderLayout.PAGE_END);
		
		jFrame.getContentPane().add(jPanel);
		
		jFrame.setLocation(300,300);
		jFrame.setSize(400,300);
		jFrame.setVisible(true);
		jFrame.show();
		textArea.requestFocus();
	}
	
	public class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Enviar (CTRL+ENTER)")) {
				enviaMensagem();
			}
			if(E.getActionCommand().equals("Fechar (ESC)")) {
				if(!textArea.isEditable())
					textArea.setEditable(true);
				else {
					historico.gravar();
					jFrame.dispose();
				}
			}
		}
	}
	
  public void enviaMensagem()
  {
    if(textArea.getText().length() != 0) {
          if(SendMessage().equals("false")) {
				JOptionPane.showMessageDialog(null,"A mensagem no foi enviada porque o usurio no est online!.\n\n");
				textArea.setEditable(true);
			}
			else {
				historico.adicionar(textArea.getText());
				areaHistorico.setText(historico.listar(3));
				verbar.setValue(verbar.getMaximum());
				textArea.setText("");
			}
	}
  }
	public String SendMessage()
	{
		String SEND="false";
		
		try
		{
			Socket MSG = new Socket(HostServer,PortServer);
			BufferedReader Reply = new BufferedReader (new InputStreamReader (MSG.getInputStream()));
			PrintWriter Send = new PrintWriter(new OutputStreamWriter(MSG.getOutputStream()));
				
			String M = "SendMessage"+Token+IdFrom+Token+IdTo+Token;
			//System.out.println(">>"+M);
			Send.println(M);
			Send.flush();
			
			Send.println(textArea.getText());
			Send.flush();
		
			SEND = Reply.readLine();
						
			MSG.close();
			Reply.close();
			Send.close();
			
		}
		catch(Exception Send)
		{
			JOptionPane.showMessageDialog(null,"Error send message.\n\n"+Send.getMessage());
			SEND="false";
		}
		return SEND;
	}
}

class MsgBoxReceive extends Thread
{     
	private JPanel jPanel, jTop, jButtons, jLabel;
	private JTextArea jTextArea, areaHistorico;
	private JButton ButtonNext, ButtonClose, ButtonReply;
	private JLabel LabelStatus;
	private JFrame jFrame;
	private Historico historico;
	private JScrollBar verbar;
	
	private StringTokenizer sTokenizer;
	private String novaMensagem, Message, IpFrom, LoginFrom, Token="~~~~~~~~~~~~~~~", HostServer;
	private int IdFrom, Amount=0, UsuarioID, PortServer;
	
	static ImageIcon iconNext = new ImageIcon("icons/ok.png");
	static ImageIcon iconClose = new ImageIcon("icons/cancel.png");
	
	public MsgBoxReceive(String HostServer, int PortServer, int UsuarioID, int IdFrom, String LoginFrom, String IpFrom, String Message)
	{
		this.IdFrom = IdFrom;
		this.LoginFrom = LoginFrom;
		this.Message = Message;
		this.IpFrom = IpFrom;
		this.UsuarioID = UsuarioID;
		this.HostServer = HostServer;
		this.PortServer = PortServer;
		historico = new Historico(IdFrom, LoginFrom);
	}
	
	public void run()
	{
		jFrame = new JFrame();
		jFrame.setTitle(LoginFrom +" - OpenChat");

		jPanel = new JPanel(new BorderLayout(0,0));
		jTop = new JPanel(new BorderLayout(0,0));
		jLabel = new JPanel(new GridLayout(2,2));
		jButtons = new JPanel(new GridLayout(1,2));
		
		ButtonNext = new JButton(iconNext);
		ButtonClose = new JButton("Fechar", iconClose);
		ButtonReply = new JButton("Responder", iconClose);
		
		novaMensagem = ReadMessage();
		jTextArea = new JTextArea(novaMensagem,5,20);
		jTextArea.setEditable(false);
		jTextArea.setBackground(Color.LIGHT_GRAY);
    
		jTextArea.addKeyListener (
		  new KeyAdapter () {
			public void keyPressed (KeyEvent e)
			{ 
			  if ((int)e.getKeyChar () == KeyEvent.VK_ESCAPE)
				jFrame.dispose();
			}
		  }
		);

		historico.adicionar(novaMensagem);
		areaHistorico = new JTextArea(7, 20);
		areaHistorico.setEditable(false);
		areaHistorico.setText(historico.listar(3));
		JScrollPane jahistorico = new JScrollPane(areaHistorico);
		verbar = jahistorico.getVerticalScrollBar();
		verbar.setMaximum(9999);
		verbar.setValue(verbar.getMaximum());
		  
    				
		LabelStatus = new JLabel(" Mensagem de "+LoginFrom+"     Id: "+IdFrom+"     IP: "+IpFrom);
				
		jLabel.add(LabelStatus);
    
		jTop.add(jLabel, BorderLayout.PAGE_START);
		jTop.add(jahistorico, BorderLayout.CENTER);
				
		jButtons.add(ButtonNext, iconNext);
		//jButtons.add(ButtonReply);
		jButtons.add(ButtonClose, iconClose);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonNext.addActionListener(handler);
		ButtonClose.addActionListener(handler);
		ButtonReply.addActionListener(handler);
				
		jPanel.add(jTop, BorderLayout.PAGE_START);
		jPanel.add(new JScrollPane(jTextArea), BorderLayout.CENTER);
		jPanel.add(jButtons, BorderLayout.PAGE_END);
		
		jFrame.getContentPane().add(jPanel);
		jFrame.setLocation(300,300);
		jFrame.setSize(400,300);
		jFrame.setVisible(true);
		jFrame.show();
    jTextArea.requestFocus();
  }
	
	private String ReadMessage()
	{
		if(Amount==0)	//not initilized
		{
			sTokenizer = new StringTokenizer(Message,Token);
			Amount = sTokenizer.countTokens();
			Amount--;
			
			if(Amount==0)
			{	
				ButtonNext.setVisible(false);
				Amount=0;
			}
			else
				ButtonNext.setText("Proximo - "+Amount);
			
		}
		return sTokenizer.nextToken();
	}
	
	private class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Proximo - "+Amount))
			{
				if(Amount > 0)
				{
					novaMensagem = ReadMessage();
					jTextArea.setText(novaMensagem);
					historico.adicionar(novaMensagem);
					areaHistorico.setText(historico.listar(3));
					verbar.setValue(verbar.getMaximum());
					Amount--;
					if(Amount == 0)
						ButtonNext.setVisible(false);
					else
						ButtonNext.setText("Proximo - "+Amount);
				}
				else
					ButtonNext.setVisible(false);
			}
			if(E.getActionCommand().equals("Fechar"))
				jFrame.dispose();
			if(E.getActionCommand().equals("Responder"))
				System.out.println("responder");
		}
	}
}

		
class About
{
	private JFrame jFrame;
	private JPanel jPanel, jAbout;
	private JButton ButtonOk;
	private JTextArea textAbout;
	private JLabel labelAbout, labelOpenChat;
		
	static ImageIcon iconLinux = new ImageIcon("icons/linux.jpg");
	static ImageIcon iconClose = new ImageIcon("icons/gnomeicu-cancel.png");
	
	public About()
	{
		jFrame = new JFrame();
		jPanel = new JPanel(new BorderLayout());
		jAbout = new JPanel(new BorderLayout());
		
		
		textAbout = new JTextArea("\nOpenChat versao 0.2final  "+
					"\n\n Autores:" +
					"\n Cesar H. Kallas" +
					"\n      cesarkallas at gmx.net"+
					"\n      http://cesarkallas.soulivre.org"+
					"\n\n Renan M. Fernandes"+
					"\n      renanfernandes at gmail.com"+
					"\n      http://renanfernandes.soulivre.org" +
					"\n Gnu Public License (GPL)\n \n \n ");
		textAbout.setEditable(false);
		
		
		textAbout.setAlignmentX(JTextArea.CENTER_ALIGNMENT);
		
		textAbout.setBackground(Color.WHITE);
		
		labelOpenChat = new JLabel("OpenChat", JLabel.CENTER);
		labelAbout = new JLabel(iconLinux);
		
		ButtonOk = new JButton("Fechar", iconClose);
		
		jAbout.add(labelAbout, BorderLayout.NORTH);
		jAbout.add(new JScrollPane(textAbout), BorderLayout.CENTER);
				
		jPanel.add(labelOpenChat, BorderLayout.PAGE_START);
		jPanel.add(jAbout, BorderLayout.CENTER);
		jPanel.add(ButtonOk, BorderLayout.PAGE_END);
		
		ButtonHandler handler = new ButtonHandler();
		ButtonOk.addActionListener(handler);
		
		jFrame.getContentPane().add(jPanel);
		
		jFrame.setTitle("About - OpenChat");
		jFrame.setResizable(true);
		jFrame.setLocation(312,289);
		jFrame.setSize(300,300);
		jFrame.setVisible(true);
		jFrame.show();
		jFrame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
	}
	
	class ButtonHandler implements ActionListener
	{
		public void actionPerformed(ActionEvent E)
		{
			if(E.getActionCommand().equals("Fechar"))
			{
				jFrame.dispose();
			}
		}
	}
}
